unit UStergArb;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons,ShellApi;

type
  TForm7 = class(TForm)
    Label1: TLabel;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form7: TForm7;

implementation

uses FMXWin;

{$R *.dfm}

procedure DeleteDirectoryTree(AHandle: THandle; const AFromDirectory, AToDirectory: String);
var
  SHFileOpStruct: TSHFileOpStruct;
  FromDir: PChar;
  ToDir: PChar;
begin

  GetMem(FromDir, Length(AFromDirectory)+2);
  try
    GetMem(ToDir, Length(AToDirectory)+2);
    try

      FillChar(FromDir^, Length(AFromDirectory)+2, 0);
      FillChar(ToDir^, Length(AToDirectory)+2, 0);

      StrCopy(FromDir, PChar(AFromDirectory));
      StrCopy(ToDir, PChar(AToDirectory));

      with SHFileOpStruct do
      begin
        Wnd    := AHandle;
        wFunc  := FO_DELETE;
        pFrom  := FromDir;
        pTo    := ToDir;
        fFlags := FOF_NOCONFIRMATION or FOF_RENAMEONCOLLISION;
        fAnyOperationsAborted := False;
        hNameMappings := nil;
        lpszProgressTitle := nil;
        if SHFileOperation(SHFileOpStruct) <> 0 then
          RaiseLastWin32Error;
      end;
    finally
      FreeMem(ToDir, Length(AToDirectory)+2);
    end;
  finally
    FreeMem(FromDir, Length(AFromDirectory)+2);
  end;
end;

procedure TForm7.BitBtn2Click(Sender: TObject);
begin
 Form7.Caption:='Stergere director';
 Close;
end;

procedure TForm7.BitBtn1Click(Sender: TObject);
begin
  ShowMessage('Se va sterge directorul '+FMForm.DirectoryOutline.Directory+'.');
  DeleteDirectoryTree(Handle,FMForm.DirectoryOutline.Directory,FMForm.DirectoryOutline.Directory);
  ShowMessage('Stergerea s-a incheiat cu succes.');
  Form7.Caption:='Stergere director';
  Close;
end;

procedure TForm7.FormActivate(Sender: TObject);
begin
  Label1.Caption:='Doriti sa stergeti directorul '+FMForm.DirectoryOutline.Directory+' ?';
end;

end.
