unit UCopiMult;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, UResGlob,StdCtrls, Buttons,ShellApi,FileCtrl, ComCtrls;

type
  TForm5 = class(TForm)
    Edit1: TEdit;
    Label1: TLabel;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    fCopy: TProgressBar;
    Label2: TLabel;
    Label3: TLabel;
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;
  TFir=class(TThread)
   protected
    procedure Execute;override;
  end;

var
  Form5: TForm5;
  Fir:TFir;
implementation

uses FMXWin;

{$R *.dfm}

procedure Final;
var
  i:integer;
begin
  Fir.Terminate;
  for i:=0 to 500 do
   begin
    fis[i]:='';
    fis_aux[i]:='';
   end;
   con_fis:=0;
   Form5.fCopy.Position:=0;
   Form5.Label2.Caption:='';
   Form5.Label3.Caption:='';
   FMForm.FileList.ClearSelection;
   //Fir.Suspend;
   Form5.Close;
   //Fir.Terminate;
end;

procedure TFir.Execute;
var
  i:integer;
  SrcFile, DestFile: File;
  BytesRead, BytesWritten, TotalRead: Integer;
  Buffer: array[1..500] of byte;
  FSize: Integer;
begin
  for i:=1 to con_fis do
  begin
  //Form5.Caption:=fis[i]+'-->'+Form5.Edit1.Text+'\'+fis_aux[i];
  Form5.Label2.Caption:='Sursa: '+fis[i];
  Form5.Label3.Caption:='Destinatia: '+Form5.Edit1.Text+'\'+fis_aux[i];
  AssignFile(SrcFile, fis[i]);
  AssignFile(DestFile, Form5.Edit1.Text+'\'+fis_aux[i]);
  Reset(SrcFile, 1);
  try
    Rewrite(DestFile, 1);
    try
      try
        TotalRead := 0;
        FSize := FileSize(SrcFile);
        repeat
          BlockRead(SrcFile, Buffer, SizeOf(Buffer), BytesRead);
          if BytesRead > 0 then
          begin
            BlockWrite(DestFile, Buffer, BytesRead, BytesWritten);
            if BytesRead <> BytesWritten then
              raise Exception.Create('Eroare copiere fisier.')
            else begin
              TotalRead := TotalRead + BytesRead;
              Form5.fCopy.Position := Trunc(TotalRead / Fsize) * 100;
              Form5.fCopy.Update;
            end;
          end
        until BytesRead = 0;
      except
        Erase(DestFile);
        raise;
      end;
    finally
      CloseFile(DestFile);
    end;
  finally
    CloseFile(SrcFile);
  end;
  end;
   Final;
end;

procedure TForm5.BitBtn2Click(Sender: TObject);
begin
 Close;
end;

procedure CopyDirectoryTree(AHandle: THandle; const AFromDirectory, AToDirectory: String);
var
  SHFileOpStruct: TSHFileOpStruct;
  FromDir: PChar;
  ToDir: PChar;
begin

  GetMem(FromDir, Length(AFromDirectory)+2);
  try
    GetMem(ToDir, Length(AToDirectory)+2);
    try

      FillChar(FromDir^, Length(AFromDirectory)+2, 0);
      FillChar(ToDir^, Length(AToDirectory)+2, 0);

      StrCopy(FromDir, PChar(AFromDirectory));
      StrCopy(ToDir, PChar(AToDirectory));

      with SHFileOpStruct do
      begin
        Wnd    := AHandle;
        wFunc  := FO_COPY;
        pFrom  := FromDir;
        pTo    := ToDir;
        fFlags := FOF_NOCONFIRMATION or FOF_RENAMEONCOLLISION;
        fAnyOperationsAborted := False;
        hNameMappings := nil;
        lpszProgressTitle := nil;
        if SHFileOperation(SHFileOpStruct) <> 0 then
          RaiseLastWin32Error;
      end;
    finally
      FreeMem(ToDir, Length(AToDirectory)+2);
    end;
  finally
    FreeMem(FromDir, Length(AFromDirectory)+2);
  end;
end;

procedure TForm5.BitBtn1Click(Sender: TObject);
var
  i,j:integer;
begin
   for i:=0 to FMForm.FileList.Count do
    if FMForm.FileList.Selected[i] then
    begin
     con_fis:=con_fis+1;
     fis[con_fis]:=FMForm.DirectoryOutline.Directory+'\'+FMForm.FileList.Items[i];
     fis_aux[con_fis]:=FMForm.FileList.Items[i];
     break;
    end;
    for j:=i+1 to FMForm.FileList.ItemIndex do
    begin
      FMForm.FileList.Selected[j]:=true;
      con_fis:=con_fis+1;
      fis[con_fis]:=FMForm.DirectoryOutline.Directory+'\'+FMForm.FileList.Items[j];
      fis_aux[con_fis]:=FMForm.FileList.Items[j];
    end;
  if con_fis=1 then
   ShowMessage('Se va copia un fisier in '+Edit1.Text+'.')
  else
   ShowMessage('Se vor copia '+inttostr(con_fis)+' fisiere in '+Edit1.Text+'.');

   Fir:=TFir.Create(false);
end;

end.
