unit URedenDir;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons,ShellApi;

type
  TForm9 = class(TForm)
    Label1: TLabel;
    Edit1: TEdit;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form9: TForm9;

implementation

uses FMXWin;

{$R *.dfm}

procedure RenameDirectoryTree(AHandle: THandle; const AFromDirectory, AToDirectory: String);
var
  SHFileOpStruct: TSHFileOpStruct;
  FromDir: PChar;
  ToDir: PChar;
begin

  GetMem(FromDir, Length(AFromDirectory)+2);
  try
    GetMem(ToDir, Length(AToDirectory)+2);
    try

      FillChar(FromDir^, Length(AFromDirectory)+2, 0);
      FillChar(ToDir^, Length(AToDirectory)+2, 0);

      StrCopy(FromDir, PChar(AFromDirectory));
      StrCopy(ToDir, PChar(AToDirectory));

      with SHFileOpStruct do
      begin
        Wnd    := AHandle;
        wFunc  := FO_MOVE;
        pFrom  := FromDir;
        pTo    := ToDir;
        fFlags := FOF_NOCONFIRMATION or FOF_RENAMEONCOLLISION;
        fAnyOperationsAborted := False;
        hNameMappings := nil;
        lpszProgressTitle := nil;
        if SHFileOperation(SHFileOpStruct) <> 0 then
          RaiseLastWin32Error;
      end;
    finally
      FreeMem(ToDir, Length(AToDirectory)+2);
    end;
  finally
    FreeMem(FromDir, Length(AFromDirectory)+2);
  end;
end;

procedure TForm9.BitBtn2Click(Sender: TObject);
begin
 Form9.Caption:='Redenumire director';
 Close;
end;

procedure TForm9.BitBtn1Click(Sender: TObject);
begin
//  SetCurrentDirectory(pchar(FMForm.DirectoryOutline.Directory));
  //Edit1.Text:=FMForm.DirectoryOutline.Directory;
  RenameDirectoryTree(Handle,FMForm.DirectoryOutline.Directory,Edit1.Text);
  ShowMessage('Directorul a fost redenumit.');
  Form9.Caption:='Redenumire director';
  Close;
end;

procedure TForm9.FormActivate(Sender: TObject);
begin
  Form9.Caption:='Redenumire director '+FMForm.DirectoryOutline.Directory;
  Edit1.Text:=FMForm.DirectoryOutline.Directory+'\';
end;

end.
